#include "stdafx.h"
#include "JSON++.h"


LPCSTR ParseReasonToStr(JSONPP::PARSE_EXCEPTION_REASON reason) noexcept
{
  switch (reason)
  {
    case JSONPP::PARSE_EXCEPTION_REASON::ENCODED_UNICODE_CHARACTER_TOO_SHORT:
    {
      return "Unicode character too short";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_ENCODED_UNICODE_CHARACTER:
    {
      return "Unexpected character in encoded unicode character";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_STRING:
    {
      return "Unexpected character in string";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_NUMBER:
    {
      return "Unexpected character in number";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_ARRAY:
    {
      return "Unexpected character in array";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_OBJECT:
    {
      return "Unexpected character in object";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_JSON:
    {
      return "Unexpected character in JSON";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_JSON_POINTER:
    {
      return "Unexpected character in JSON Pointer";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::COULD_NOT_FIND_CHILD_IN_OBJECT:
    {
      return "Could not find child in object";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::COULD_NOT_FIND_CHILD_IN_ARRAY:
    {
      return "Could not find child in array";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::CURRENT_ITEM_IS_NOT_OBJECT_OR_ARRAY:
    {
      return "Current item is not object or array";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_MULTI_LINE_COMMENT:
    {
      return "Unexpected character in multi line comment";
      break;
    }
    case JSONPP::PARSE_EXCEPTION_REASON::UNEXPECTED_CHARACTER_IN_JSON5_IDENTIFIER:
    {
      return "Unexpected character in JSON5 identifier";
      break;
    }
    default:
    {
#pragma warning(suppress: 26477)
      ATLASSERT(FALSE);
      return "Unknown";
      break;
    }
  }
}

#pragma warning(suppress: 26485)
int _tmain(int argc, TCHAR* argv[]) //NOLINT(modernize-avoid-c-arrays)
{
  //Exercise the CValue class
  JSONPP::CValue value1;
  assert(value1.IsNull());
  const auto t{value1.Type()};
  UNREFERENCED_PARAMETER(t);
  std::wstring sTemp{value1.Encode()};
  JSONPP::CValue value2{true};
  assert(value2.IsBoolean());
  auto b{value2.AsBoolean()};
  UNREFERENCED_PARAMETER(b);
  sTemp = value2.Encode();
  JSONPP::CValue value3{false};
  assert(value3.IsBoolean());
  b = value3.AsBoolean();
  UNREFERENCED_PARAMETER(b);
  sTemp = value3.Encode();
  JSONPP::CValue value4{42.1};
  assert(value4.IsNumber());
  auto n{value4.AsNumber()};
  UNREFERENCED_PARAMETER(n);
  sTemp = value4.Encode();
  JSONPP::CValue value5{42L};
  assert(value5.IsNumber());
  n = value5.AsNumber();
  UNREFERENCED_PARAMETER(n);
  sTemp = value5.Encode();
  sTemp = value5.Encode(JSONPP::ENCODE_FLAGS::ENCODE_JSON5);
  JSONPP::CValue value6{std::wstring{L"AString\"test1\\test2/test3\btest4\ftest5\nte\x03st6\rtest7\ttest8"}};
  assert(value6.IsString());
  auto s{value6.AsString()};
  wprintf(L"%s\n", value6.Encode().c_str());
  wprintf(L"%s\n", value6.Encode(JSONPP::ENCODE_NON_ASCII_CHARACTERS).c_str());
  wprintf(L"%s\n", value6.Encode(JSONPP::ENCODE_ALL_UNICODE_CHARACTERS).c_str());
  value6 = std::wstring{L"\u1234"};
  wprintf(L"%s\n", value6.Encode(JSONPP::ENCODE_ALL_UNICODE_CHARACTERS).c_str());
  JSONPP::CValue value7{std::numeric_limits<double>::quiet_NaN()};
  assert(value7.IsNumber());
  n = value7.AsNumber();
  sTemp = value7.Encode();
  sTemp = value7.Encode(JSONPP::ENCODE_FLAGS::ENCODE_JSON5);
  UNREFERENCED_PARAMETER(n);
  sTemp = value7.Encode();
  JSONPP::CValue value8{std::numeric_limits<double>::infinity()};
  assert(value8.IsNumber());
  n = value8.AsNumber();
  UNREFERENCED_PARAMETER(n);
  sTemp = value8.Encode();
  sTemp = value8.Encode(JSONPP::ENCODE_FLAGS::ENCODE_JSON5);
  value8.SetNull();
  value8 = value1;
  value8 = value2;
  value8 = value3;
  value8 = value4;
  value8 = value5;
  value8 = value6;
  value8 = value7;
  auto sizet = value8.CountChildren();
  UNREFERENCED_PARAMETER(sizet);
  b = value8.HasChild(L"doesNotExist");
  UNREFERENCED_PARAMETER(b);
  b = value8.HasChild(66);
  UNREFERENCED_PARAMETER(b);
  value8 = 1.3;
  value8 = 42L;
  value8 = L"another string";
  value8 = std::wstring{L"another string2"};
  value8 = false;
  value8 = L"\u0041\u0053\u0074\u0072\u0069\u006E\u0067";
  value8.Parse(L"\"\u0041\u0053\u0074\u0072\u0069\u006E\u0067\"");
  JSONPP::CValue value9{L"AString"};
  value9.Parse(L"40.9358215191158457340974");
  assert(value9.AsNumber() == 40.9358215191158457340974);
  sTemp = value9.Encode();
  value9.Parse(L"1.00034985734000");
  assert(value9.AsNumber() == 1.00034985734000);
  sTemp = value9.Encode();
  value9.Parse(L"{\"test\":\"Value \\u00E0\"}");
  std::wstring sEncode = value9.Encode(JSONPP::ENCODE_NON_ASCII_CHARACTERS);

  JSONPP::CValue value10{value1};
  JSONPP::CValue value11{value2};
  JSONPP::CValue value12{value3};
  JSONPP::CValue value13{value4};
  JSONPP::CValue value14{value5};
  JSONPP::CValue value15{value6};
  JSONPP::CValue value16{value7};
  JSONPP::CValue value17{value8};
  std::wstring str1{L"AString"};
  JSONPP::CValue value18{str1};
  assert(value18.IsString());
  s = value18.AsString();
  sTemp = value18.Encode();
  value8 = str1;

  JSONPP::Array arr1;
  arr1.push_back(value10);
  arr1.push_back(value11);
  arr1.push_back(value12);
  arr1.push_back(value13);
  arr1.push_back(value14);
  arr1.push_back(value15);
  arr1.push_back(value16);
  arr1.push_back(value17);
  JSONPP::CValue value19{arr1};
  assert(value19.IsArray());
  auto arr{value19.AsArray()};
  sTemp = value19.Encode();
  sizet = value19.CountChildren();
  UNREFERENCED_PARAMETER(sizet);
  b = value19.HasChild(4);
  UNREFERENCED_PARAMETER(b);
  b = value19.HasChild(42);
  UNREFERENCED_PARAMETER(b);
  auto child{value19.Child(4)};
  UNREFERENCED_PARAMETER(child);
  value19.SetNull();
  value19 = arr1;
  JSONPP::CValue value20{value19};
  assert(value20.IsArray());
  arr = value20.AsArray();
  sTemp = value20.Encode();

  JSONPP::CValue value22{JSONPP::CValue(L"Str")};
  JSONPP::CValue value23{JSONPP::CValue(33.6)};

  JSONPP::Object obj1;
  obj1[L"duck"] = value10;
  obj1[L"mouse"] = value11;
  obj1[L"cat"] = value12;
  obj1[L"dog"] = value13;
  obj1[L"fox"] = value14;
  obj1[L"tree"] = value15;
  obj1[L"fish"] = value16;
  obj1[L"lion"] = value17;

  JSONPP::CValue value24{obj1};
  assert(value24.IsObject());
  auto obj{value24.AsObject()};
  sTemp = value24.Encode();
  sizet = value24.CountChildren();
  UNREFERENCED_PARAMETER(sizet);
  bool bHasChild = value24.HasChild(L"doesnotexist");
  UNREFERENCED_PARAMETER(bHasChild);
  bHasChild = value24.HasChild(L"dog");
  UNREFERENCED_PARAMETER(bHasChild);
  child = value24.Child(L"dog");
  value24.SetNull();
  value24 = obj1;
  JSONPP::CValue value25{value24};
  assert(value25.IsObject());
  obj = value25.AsObject();
  sTemp = value25.Encode();
  auto objectKeys(value25.ObjectKeys());

  value1 = JSONPP::CValue{};
  value1 = JSONPP::CValue{L"tree"};
  value1 = JSONPP::CValue{7.1};
  value1 = JSONPP::CValue{true};
  value5 = value24;
  value5 = value25;
  value1 = value20;

  JSONPP::CValue value27{JSONPP::CValue{L"tree"}};
  JSONPP::CValue value28{JSONPP::CValue{7.1}};
  JSONPP::CValue value29{JSONPP::CValue{true}};
  JSONPP::CValue value32{JSONPP::Object{std::make_pair(L"Name1", L"foo"), std::make_pair(L"Name2", L"bar")}};
  value32 = JSONPP::Object{ std::make_pair(L"Name3", L"bar"), std::make_pair(L"Name4", L"foo") };
  JSONPP::CValue value33(JSONPP::Array{JSONPP::CValue{7.1}, JSONPP::CValue{L"tree"}});
  value33 = JSONPP::CValue{JSONPP::Array{JSONPP::CValue{7.2}, JSONPP::CValue{L"tree_new"}}};
  value33 = JSONPP::Array{JSONPP::CValue{7.2}, JSONPP::CValue{L"tree_new"}};
  JSONPP::CValue value34{JSONPP::CValue{JSONPP::Object{std::make_pair(L"Name1", L"foo"), std::make_pair(L"Name2", L"bar")}}};
  value34 = JSONPP::CValue{JSONPP::Object{std::make_pair(L"Name1", L"foo"), std::make_pair(L"Name2", L"bar")}};
  value34 = JSONPP::Object{std::make_pair(L"Name1", L"foo"), std::make_pair(L"Name2", L"bar")};
  JSONPP::CValue value35{JSONPP::CValue{JSONPP::Array{JSONPP::CValue{7.1}, JSONPP::CValue{L"tree"}}}};

  JSONPP::CValue value30;
  value30.Parse(L"null");
  value30.Parse(L"true");
  value30.Parse(L"false");
  //value30.Parse(L"\"AStringtest1\\test2/test3\btest4\ftest5\ntest6\rtest7\ttest8\"");

  try
  {
    value30.Parse(L"  \"AStringtest1\\test2/test3\\btest4\\ftest5\\nte\\/st6\\rte\\u0045st7\\tte\\\"st8\\u1234\"");
    value30.Parse(L"  ");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1");
  try
  {
    value30.Parse(L"1.");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1.2");
  value30.Parse(L"-1");
  try
  {
    value30.Parse(L"-1.");
  }
  catch (JSONPP::CParseException& )
  {
  }
  value30.Parse(L"-1.2");
  value30.Parse(L"0");
  try
  {
    value30.Parse(L"0.");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"0.2");
  value30.Parse(L"-0");
  try
  {
    value30.Parse(L"-0.");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"-0.2");
  try
  {
    value30.Parse(L"1E");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"1.E");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"1.2E");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1E");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1.E");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1.2E");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"1EA");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"1.EA");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"1.2EA");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1EA");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1.EA");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1.2EA");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1E2");
  try
  {
    value30.Parse(L"1.E2");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1.2E2");
  value30.Parse(L"-1E2");
  try
  {
    value30.Parse(L"-1.E2");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"-1.2E2");
  value30.Parse(L"1E+2");
  try
  {
    value30.Parse(L"1.E+2");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1.2E+2");
  value30.Parse(L"-1E+2");
  try
  {
    value30.Parse(L"-1.E+2");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"-1.2E+2");
  value30.Parse(L"1E-2");
  try
  {
    value30.Parse(L"1.E-2");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1.2E-2");
  value30.Parse(L"-1E-2");
  try
  {
    value30.Parse(L"-1.E-2");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"-1.2E-2");
  value30.Parse(L"1E23");
  try
  {
    value30.Parse(L"1.E23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1.2E23");
  value30.Parse(L"-1E23");
  try
  {
    value30.Parse(L"-1.E23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"-1.2E23");
  value30.Parse(L"1E+23");
  try
  {
    value30.Parse(L"1.E+23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1.2E+23");
  value30.Parse(L"-1E+23");
  try
  {
    value30.Parse(L"-1.E+23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"-1.2E+23");
  value30.Parse(L"1E-23");
  try
  {
    value30.Parse(L"1.E-23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"1.2E-23");
  value30.Parse(L"-1E-23");
  try
  {
    value30.Parse(L"-1.E-23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"-1.2E-23");
  try
  {
    value30.Parse(L"1E@23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"1.E@23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"1.2E@23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1E@23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1.E@23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-1.2E@23");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"0.A");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"1A");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-20.A");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"-A");
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    value30.Parse(L"\"string");
  }
  catch (JSONPP::CParseException&)
  {
  }

  value30.Parse(L"[\t 1  , \"string\", null, true, false]", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  wprintf(L"%s\n", value30.Encode(JSONPP::NONE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::THREE_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::FOUR_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::PRETTY_PRINT_ONE_SPACE).c_str());
  value30.Parse(L"[\t 1  , \"string\", null, true, [\t 1  , \"string\", null, true, [\t 1  , \"string\", null, true, false]], false]");
  value30.Parse("[\t 1  , \"string\", null, true, [\t 1  , \"string\", null, true, [\t 1  , \"string\", null, true, false]], false]");
  wprintf(L"%s\n", value30.Encode(JSONPP::NONE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::THREE_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::FOUR_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::INDENT_SUB_ARRAYS | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::PRETTY_PRINT_ONE_SPACE).c_str());
  value30.Parse(L"[\t ]");
  try
  {
    value30.Parse(L"[\t ");
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L"{\t 1  , \"string\", null, true, false}", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"{\t }");
  try
  {
    value30.Parse(L"{\t ");
  }
  catch (JSONPP::CParseException&)
  {
  }

  value30.Parse(L"{\t \"name1\" : \t 1  , \"name2\"  : \"string\", \"name3\"  :null, \"name4\"  :true, \"name4\"  :false}");
  wprintf(L"%s\n", value30.Encode(JSONPP::NONE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::THREE_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::FOUR_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::PRETTY_PRINT_ONE_SPACE).c_str());
  value30.Parse(L"{\t \"name1\" : \t 1  , \"name2\"  : \"string\", \"name3\"  :null, \"name4\"  :true, \"name4\"  :false, \"Sub1\" : {\t \"name5\" : \t 1  , \"name6\"  : \"string\", \"name7\"  :null, \"name8\"  :true, \"name9\"  :false} }");
  value30.Parse(L"{\t \"name1\" : \t 1  , \"name2\"  : \"string\", \"name3\"  :null, \"name4\"  :true, \"name4\"  :false, \"Sub1\" : {\t \"name5\" : \t 1  , \"name6\"  : \"string\", \"name7\"  :null, \"name8\"  :true, \"name9\"  : { \"name10\" : \t 1  , \"name11\"  : \"string\", \"name12\"  :null, \"name13\"  :true, \"name14\" : false } } }");
  wprintf(L"%s\n", value30.Encode(JSONPP::NONE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::INDENT_SUB_OBJECTS | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::THREE_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::FOUR_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::THREE_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::FOUR_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::PRETTY_PRINT_ONE_SPACE).c_str());
  value30.Parse(L"{\t \"name1\" : \t 1  , \"name2\"  : \"string\", \"name3\"  :null, \"name4\"  :true, \"name4\"  :false, \"Sub1\" : {\t \"name5\" : \t 1  , \"name6\"  : \"string\", \"name7\"  :null, \"name8\"  :true, \"name9\"  : [\t 1, \"string\", null, true, false] } }");
  wprintf(L"%s\n", value30.Encode(JSONPP::NONE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::WHITESPACE_AFTER_VALUE | JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::INDENT_SUB_OBJECTS | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::ONE_SPACE | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::TWO_SPACES | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::THREE_SPACES | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::FOUR_SPACES | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::TABS | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::ONE_SPACE | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::TWO_SPACES | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::THREE_SPACES | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::FOUR_SPACES | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BETWEEN_OBJECT_NAME_AND_VALUES | JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::TABS | JSONPP::WHITESPACE_AFTER_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::ONE_SPACE).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::TWO_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::THREE_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::FOUR_SPACES).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::WHITESPACE_BEFORE_VALUE | JSONPP::TABS).c_str());
  wprintf(L"%s\n", value30.Encode(JSONPP::PRETTY_PRINT_ONE_SPACE).c_str());

  try
  {
    value30.Parse(L"{\t \"name1\" : ");
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L"{\t \"name1\" : \t 1  * ");
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L"{\t \"name1\" * ");
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L"[\t * ");
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L"[\t 1 * ");
  }
  catch (JSONPP::CParseException&)
  {
  }

  value30.Parse(L"{ \"positiveInfinity\": Infinity, negativeInfinity : -Infinity, notANumber : NaN, positiveInfinity2 : +Infinity, notANumber2 : SNaN, notANumber3 : QNaN, positiveInfinity3 : +Inf, positiveInfinity4 : Inf, NegativeInfinity2 : -Inf}", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  sTemp = value30.Encode();
  sTemp = value30.Encode(JSONPP::ENCODE_FLAGS::ENCODE_JSON5);
  value30.Parse(L"{ integer: 123, withFractionPart : 123.456, onlyFractionPart : .456, withExponent : 123e-456, integerWithLeadingPlus: +123 }", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"\'Single Quoted String\'", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L".8675309", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"8675309.", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"{ positiveHex: 0xdecaf, positiveHex2: +0xdeCAF, negativeHex : -0xC0FFEE }", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);

  try
  {
    value30.Parse(L"{ \"PositiveInteger\": +123");
  }
  catch (JSONPP::CParseException&)
  {
  }
  value30.Parse(L"{ PositiveInteger: +123}", 20, JSONPP::PARSE_FLAGS::PARSE_JSON5);

  try
  {
    value30.Parse(L"{ \"PositiveInteger\": +123 }");
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L" 0x ", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L" \"\\u123\" ", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L"\\uABCG", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L" \"\\u\"", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  value30.Parse(L" \"\\u012a\"", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L" \"\\x1a\"", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L" \"\\x1F\"", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);

  try
  {
    value30.Parse(L" \"\t\"", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L" \"\\x4", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  value30.Parse(L" \"\\x45\\0\\v\\\\\"", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L" \"\\\\\"", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);

  try
  {
    value30.Parse(L" \"\\xGF", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L" \"\\kGF", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L" \"\\kGF");
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L"-0x ", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L" 0XFG ", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(LR"({
      // comments
      unquoted: 'and you can quote me on that',
      singleQuotes : 'I can use "double quotes" here',
      lineBreaks : "Look, Mom! \
No \\n's!",
hexadecimal : 0xdecaf,
leadingDecimalPoint : .8675309, andTrailing : 8675309.,
positiveSign : +1,
trailingComma : 'in objects', andIn : ['arrays', ] ,
"backwardsCompatible" : "with JSON",
  })");
  }
  catch (JSONPP::CParseException&)
  {
  }

  value30.Parse(L"{// a comment\r\nunquoted: 'and you can quote me on that' }", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"{/* a comment\r\n continued onto another line*/unquoted: 'and you can quote me on that' }", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"{lineBreaks : \"Look, Mom! \\\r\nSecond line!\"}", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"'Lorem ipsum dolor sit amet, \\\r\nconsectetur adipiscing elit.'", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"'\\A\\C\\/\\D\\C'", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"{ \"Parameter\" : \"value\", }", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"[ 12, null, \"string\", ]", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  value30.Parse(L"{ \\x45\\f\\t\\\"\\A\\C\\/\\D\\C\\t : true, }", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);

  value30.Parse(LR"({
      // comments
      unquoted: 'and you can quote me on that',
      singleQuotes : 'I can use "double quotes" here',
      line\
Breaks : "Look, Mom! \
No \\n's!",
hexadecimal : 0xdecaf,
leadingDecimalPoint : .8675309, andTrailing : 8675309.,
positiveSign : +1,
trailingComma : 'in objects', andIn : ['arrays', ] ,
"backwardsCompatible" : "with JSON",
  })", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);


  try
  {
    value30.Parse(L"'\\A\\0\\/\\3\\C'", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  try
  {
    value30.Parse(L"{/* a comment\r\n continued onto another line", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);
  }
  catch (JSONPP::CParseException&)
  {
  }

  value30.Parse(LR"({lineBreaks : "Look, Mom! \
No \\n's!"})", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);

  value30.Parse(LR"({
      // comments
      unquoted: 'and you can quote me on that',
      singleQuotes : 'I can use "double quotes" here',
      lineBreaks : "Look, Mom! \
No \\n's!",
hexadecimal : 0xdecaf,
positiveSign : +1,
trailingComma : 'in objects', andIn : ['arrays' ] ,
"backwardsCompatible" : "with JSON"
  })", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);

  value30.Parse(LR"({
      // comments
      unquoted: 'and you can quote me on that',
      singleQuotes : 'I can use "double quotes" here',
      lineBreaks : "Look, Mom! \
No \\n's!",
hexadecimal : 0xdecaf,
leadingDecimalPoint : .8675309, andTrailing : 8675309.,
positiveSign : +1,
trailingComma : 'in objects', andIn : ['arrays', ] ,
"backwardsCompatible" : "with JSON",
  })", -1, JSONPP::PARSE_FLAGS::PARSE_JSON5);

#pragma warning(suppress: 26472)
  wprintf(L"Size of std::wstring %d bytes\n", static_cast<int>(sizeof(std::wstring)));
#pragma warning(suppress: 26472)
  wprintf(L"Size of double %d bytes\n", static_cast<int>(sizeof(double)));
#pragma warning(suppress: 26472)
  wprintf(L"Size of JSONPP::Object %d bytes\n", static_cast<int>(sizeof(JSONPP::Object)));
#pragma warning(suppress: 26472)
  wprintf(L"Size of JSONPP::Array %d bytes\n", static_cast<int>(sizeof(JSONPP::Array)));
#pragma warning(suppress: 26472)
  wprintf(L"Size of bool %d bytes\n", static_cast<int>(sizeof(bool)));
#pragma warning(suppress: 26472)
  wprintf(L"Size of CValue %d bytes\n", static_cast<int>(sizeof(value1)));
#pragma warning(suppress: 26472)
  wprintf(L"Size of CValue::TYPE %d bytes\n", static_cast<int>(sizeof(JSONPP::TYPE)));

  //Test out the JSON Pointer support (using raw string literals while we are at it)
  value30.Parse(R"({ "foo": ["bar", "baz", true], "": 0, "a/b": 1, "c%d": 2, "e^f": 3, "g|h": 4, "i\\j": 5, "k\"l": 6, " ": 7, "m~n": 8, "X": {"Y" : 9, "Z" : 10 } })");
  sEncode = value30.Encode();
  JSONPP::CValue* pPointer{value30.JSONPointer(L"")}; //NOLINT(clang-analyzer-deadcode.DeadStores)
  try
  {
    pPointer = value30.JSONPointer(L"X"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"X"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  pPointer = value30.JSONPointer(L"/foo");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/foo/0");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer("/foo/0");
  sEncode = pPointer->Encode();
  try
  {
    pPointer = value30.JSONPointer(L"/foo/BAR"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/foo/BAR/BAR2"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/foo//"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/foo/-1"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/foo/42"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/foo/42/43"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/foo/1/43"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/foo/2/43/"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/\\u1fAG"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  try
  {
    pPointer = value30.JSONPointer(L"/\t"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  pPointer = value30.JSONPointer(L"/");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/a~1b");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/c%d");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/e^f");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/g|h");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/i\\\\j");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/k\"l");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/ ");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/\\u0020");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/m~0n");
  sEncode = pPointer->Encode();
  try
  {
    pPointer = value30.JSONPointer(L"/doesnotexist"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  pPointer = value30.JSONPointer(L"/X");
  sEncode = pPointer->Encode();
  try
  {
    pPointer = value30.JSONPointer(L"/X/Q/R"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  }
  catch (JSONPP::CParseException&)
  {
  }
  pPointer = value30.JSONPointer(L"/X/Y");
  sEncode = pPointer->Encode();
  pPointer = value30.JSONPointer(L"/X/Z");
  sEncode = pPointer->Encode();

  if (argc < 2)
  {
    _ftprintf(stderr, _T("JSON++ FileToParse [#TestRuns]\n"));
    return 1;
  }
  int nRuns = 50000;
  if (argc <= 3)
#pragma warning(suppress: 26481)
    nRuns = _ttoi(argv[2]);

  //Some throw away test code to parse a JSON file if specified on the command line
  ATL::CAtlFile file;
#pragma warning(suppress: 26481)
  HRESULT hr = file.Create(argv[1], GENERIC_READ, FILE_SHARE_READ, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN);
  if (FAILED(hr))
  {
#pragma warning(suppress: 26472 26481)
    _ftprintf(stderr, _T("Failed to open file:%s, Error:%08X\n"), argv[1], static_cast<unsigned int>(hr));
    return 1;
  }
  ULONGLONG nFileSize = 0;
  hr = file.GetSize(nFileSize);
  if (FAILED(hr))
  {
#pragma warning(suppress: 26472 26481)
    _ftprintf(stderr, _T("Failed to get file size for file:%s, Error:%08X\n"), argv[1], static_cast<unsigned int>(hr));
    return 1;
  }
  if (nFileSize > LONG_MAX)
  {
#pragma warning(suppress: 26481)
    _ftprintf(stderr, _T("file %s is too big to parse\n"), argv[1]);
    return 1;
  }
  std::vector<char> readBuf;
#pragma warning(suppress: 26472)
  readBuf.resize(static_cast<size_t>(nFileSize + 1));
  DWORD dwRead{0};
#pragma warning(suppress: 26472)
  hr = file.Read(readBuf.data(), static_cast<DWORD>(nFileSize), dwRead);
  if (FAILED(hr))
  {
#pragma warning(suppress: 26472 26481)
    _ftprintf(stderr, _T("Failed to read from file:%s, Error:%08X\n"), argv[1], static_cast<unsigned int>(hr));
    return 1;
  }
#pragma warning(suppress: 26477)
  ATLASSUME(dwRead == nFileSize);
  if (dwRead != nFileSize)
  {
#pragma warning(suppress: 26481)
    _ftprintf(stderr, _T("Failed to read correct size from file:%s\n"), argv[1]);
    return 1;
  }
  //Null terminate the data
#pragma warning(suppress: 26446 26472)
  readBuf[static_cast<size_t>(nFileSize)] = '\0';

  //Try to parse the JSON
  bool bValidJSONFile = false;
  try
  {
    JSONPP::CValue value36;
    value36.Parse(readBuf.data());
#pragma warning(suppress: 26481)
    printf("Successfully parsed JSON from file:%s, JSON:%s\n", ATL::CT2A(argv[1]).operator LPSTR(), readBuf.data());
    sEncode = value36.Encode();
    wprintf(L"Encoded: %s\n", sEncode.c_str());
    bValidJSONFile = true;
  }
#pragma warning(suppress: 26496)
  catch (JSONPP::CParseException& e)
  {
#pragma warning(suppress: 26481 26472)
    printf("Failed to parse JSON from file:%s, JSON:%s, Error:%s, Offset:%d\n", ATL::CT2A(argv[1]).operator LPSTR(), readBuf.data(), ParseReasonToStr(e.m_Reason), static_cast<int>(e.m_nIndex));
  }

  //Now do some perf testing with the new code
  if (bValidJSONFile)
  {
    ULONGLONG nStartTick{GetTickCount64()};
    JSONPP::CValue value36;
    for (int i=0; i<nRuns; i++)
      value36.Parse(readBuf.data());
    ULONGLONG nTimeTaken{GetTickCount64() - nStartTick};
    wprintf(L"Time taken to parse UTF8 JSON %d times with JSON++ is: %I64u ms\n", nRuns, nTimeTaken);

    std::wstring sEncoded;
    nStartTick = GetTickCount64();
    for (int i=0; i<nRuns; i++)
      sEncoded = value36.Encode();
    nTimeTaken = GetTickCount64() - nStartTick;
    wprintf(L"Time taken to encode %d times with JSON++ is: %I64u ms\n", nRuns, nTimeTaken);

    std::wstring sWideString(JSONPP::CValue::UTF82W(readBuf.data()));
    JSONPP::CValue value37;
    nStartTick = GetTickCount64();
    for (int i=0; i< nRuns; i++)
      value37.Parse(sWideString.c_str());
    nTimeTaken = GetTickCount64() - nStartTick;
    wprintf(L"Time taken to parse UTF16 JSON %d times with JSON++ is: %I64u ms\n", nRuns, nTimeTaken);

    JSONPP::CValue value38;
    for (int j=32; j<=1024; j+=32)
    {
      nStartTick = GetTickCount64();
      for (int i=0; i<nRuns; i++)
          value38.Parse(sWideString.c_str(), j);
      nTimeTaken = GetTickCount64() - nStartTick;
      wprintf(L"Time taken to parse UTF16 JSON %d times with JSON++ (StringReserveSize is %d) is: %I64u ms\n", nRuns, j, nTimeTaken);
    }
  }
}
